<?php
session_start();
header("Content-Type: text/html; charset=utf-8");

$db = sen_db_open('sbsenna') or showerror('Sennãf[^x[XJƂł܂B');
$ctx = sen_ctx_open($db, SEN_CTX_USEQL);

function showerror($errstr = 'error') {
  echo $errstr;
  end_senna();
}

function def_sen_output() {
  // ƌʂTSVAĕԂAsen-outputƂ֐`
  query('
    (define (sen-output . x)
     (disp (car x).:nr :tsv)
     (disp (cons : x) :tsv))
  ');
}

function def_addbookmark() {
  // ubN}[Nǉ֐ add_bookmark`
  query('
    (define (add_bookmark item_url item_title comment_author comment_content comment_issued)
     (let ((item (or (<items> : item_url) (<items> ::new item_url :title item_title)))
           (id (+ (<comments> ::nrecords) 1)))
      (<comments> ::new id
       :item item
       :author comment_author
       :content comment_content
       :issued comment_issued)))
  ');
}

function getuserid($showerror = false) {
  if (!isset($_SESSION['userid'])) {
    if ($showerror) {
      showerror('sen_ctx_send error');
    } else {
      return null;
    }
  }
  return $_SESSION['userid'];
}

function getusername($userid) {
  $username = query(
    array("
      (disp (<users> : ?).name :tsv)
    ", $userid));
  return $username[0];
}

function query($query)
{
  global $ctx;
  // z̏ꍇsen_ctx_sendSEN_CTX_MORE3ɓn
  // z̗vfꂼ𑗂
  if (is_array($query)) {
    if (count($query) == 0) {
      showerror('query error: empty array');
    }
    $last = array_pop($query);
    foreach ($query as $q) {
      if (sen_ctx_send($ctx, $q, SEN_CTX_MORE) != 0) {
        showerror('sen_ctx_send error');
      }
    }
    $query = $last;
  }
  if (sen_ctx_send($ctx, $query, 0) != 0) {
    showerror('sen_ctx_send error');
  }

  $res = array();
  do {
    list($rc, $str, $flags) = sen_ctx_recv($ctx);
    if ($rc != 0) { showerror('sen_ctx_recv error: '.$rc); }
    array_push($res, $str);
  } while($flags & SEN_CTX_MORE);

  return $res;
}

function end_senna()
{
  global $ctx, $db;
  if ($ctx) {
    sen_ctx_close($ctx);
  }
  if ($db) {
    sen_db_close($db);
  }
  exit();
}

function getparam($key) {
  return isset($_POST[$key]) ? $_POST[$key] : $_GET[$key];
}
?>
